<HTML>
<HEAD>
<TITLE>AspPDF Template Fill-out Demo</TITLE>

<script language="JavaScript">

function Validate()
{
	if( Form.Name.value == "" && Form.BusinessName.value == "" )
	{
		alert('Either Name or Business Name fields must be filled in.' );
		Form.Name.focus();
		return false;
	}

	if( Form.Type[3].checked && Form.Other.value == "" )
	{
		alert('Business type must be filled in.' );
		Form.Other.focus();
		return false;
	}

	if( Form.Address.value == "" )
	{
		alert('Address must be filled in.' );
		Form.Address.focus();
		return false;
	}

	if( Form.City.value == "" )
	{
		alert('City must be filled in.' );
		Form.City.focus();
		return false;
	}

	if( Form.State.value == "" )
	{
		alert('State must be filled in.' );
		Form.State.focus();
		return false;
	}

	if( Form.Zip.value == "" )
	{
		alert('Zip must be filled in.' );
		Form.Zip.focus();
		return false;
	}

	if( !Form.TIN[0].checked && !Form.TIN[1].checked )
	{
		alert('You must select either SSN or EIN.' );
		Form.SSN.focus();
		return false;
	}

	if( Form.TIN[0].checked && Form.SSN.value == "" )
	{
		alert('SSN must be filled in.' );
		Form.SSN.focus();
		return false;
	}

	if( Form.TIN[1].checked && Form.EIN.value == "" )
	{
		alert('EIN must be filled in.' );
		Form.EIN.focus();
		return false;
	}

	return true;
}

</script>

</HEAD>
<BODY>

<TABLE WIDTH="640"><TR><TD>
<FONT FACE="Arial" SIZE="2">
<A HREF="images/w9.pdf"><IMG ALT="Download the original (blank) form W-9 here" SRC="images/w9.gif" ALIGN="RIGHT" BORDER="0"></A>
<h3>AspPDF Template Fill-out Demo</h3>
AspPDF is capable of printing and drawing over existing PDF documents.
This demo enables you to programmatically fill out the IRS W-9 form with
data coming from an HTML form.

<P>
<TABLE BORDER="0" CELLSPACING="3" CELLPADDING="0" STYLE="font-name:arial; font-size: 12">

<FORM NAME="Form" ACTION="demo_fill.asp" OnSubmit="return Validate();" METHOD="POST">

<TR><TD><B>Name</B>:</TD><TD><INPUT OnFocus="this.form.Type[0].checked=true;" SIZE="40" TYPE="TEXT" NAME="Name" VALUE="<% = Request("Name") %>"></TD></TR>

<TR><TD><B>Business Name</B>:</TD><TD><INPUT SIZE="40" TYPE="TEXT" NAME="BusinessName" VALUE="<% = Request("BusinessName") %>"></TD></TR>

<TR><TD VALIGN="TOP"><B>Type</B>:</TD><TD>
	<INPUT TYPE="RADIO" NAME="Type" VALUE="0"<% If Request("Type") = "0" or Request("Type") = "" Then Response.Write " CHECKED" %>>Individual/Sole Proprietor<BR>
	<INPUT TYPE="RADIO" NAME="Type" VALUE="1"<% If Request("Type") = "1" Then Response.Write " CHECKED" %>>Corporation<BR>
	<INPUT TYPE="RADIO" NAME="Type" VALUE="2"<% If Request("Type") = "2" Then Response.Write " CHECKED" %>>Partnership<BR>
	<INPUT TYPE="RADIO" NAME="Type" VALUE="3"<% If Request("Type") = "3" Then Response.Write " CHECKED" %>>Other  <INPUT TYPE="TEXT" OnFocus="this.form.Type[3].checked=true;" NAME="Other" VALUE="<% = Request("Other") %>">
</TD></TR>

<TR><TD><B>Exempt from<BR>backup<BR>withholdings</B>?</TD><TD><INPUT TYPE="CHECKBOX" NAME="Exempt"<% If Request("Exempt") = "on" Then Response.Write " CHECKED" %>></TD></TR>

<TR><TD><B>Street Address</B>:</TD><TD><INPUT SIZE="40" TYPE="TEXT" NAME="Address" VALUE="<% = Request("Address") %>"></TD></TR>

<TR><TD><B>City</B>:</TD><TD><INPUT SIZE="40" TYPE="TEXT" NAME="City" VALUE="<% = Request("City") %>"></TD></TR>
<TR><TD><B>State</B>:</TD><TD><INPUT SIZE="2" TYPE="TEXT" NAME="State" VALUE="<% = Request("State") %>"></TD></TR>
<TR><TD><B>Zip</B>:</TD><TD><INPUT SIZE="10" TYPE="TEXT" NAME="Zip" VALUE="<% = Request("Zip") %>"></TD></TR>

<TR><TD VALIGN="CENTER"><B>Taxpayer Number</B>:</TD><TD>
	<TABLE BORDER=0 CELLSPACING=2 CELLPADDING=0 STYLE="font-name:arial; font-size: 12">
	<TR><TD><INPUT TYPE="RADIO" NAME="TIN" VALUE="0"<% If Request("TIN") = "0" Then Response.Write " CHECKED" %>>SSN</TD><TD><INPUT TYPE="TEXT" NAME="SSN" OnFocus="this.form.TIN[0].checked=true;" VALUE="<% = Request("SSN") %>"></TD></TR>
	<TR><TD><INPUT TYPE="RADIO" NAME="TIN" VALUE="1"<% If Request("TIN") = "1" Then Response.Write " CHECKED" %>>EIN</TD><TD><INPUT TYPE="TEXT" NAME="EIN" OnFocus="this.form.TIN[1].checked=true;" VALUE="<% = Request("EIN") %>"></TD></TR>
	</TABLE>
</TD></TR>

<TR><TD COLSPAN="2"><INPUT TYPE="SUBMIT" NAME="Save" VALUE="Generate PDF"></TD></TR>

</FORM>
</TABLE>

<%
	If Request("Save") <> "" Then

		Set PDF = Server.CreateObject("Persits.PDF")

		' Open an existing document, form W-9
		Set Doc = PDF.OpenDocument( Server.MapPath( "images/w9.pdf" ) )

		' Obtain Page object for page 1
		Set Page = Doc.Pages(1)

		' Create empty param object to be used throughout application
		Set Param = PDF.CreateParam

		' Create font object
		Set Font = Doc.Fonts("Helvetica-Bold")

		' Name
		Param.Add("x=70, y=698")
		Page.Canvas.DrawText Request("Name"), Param, Font

		' Business Name
		Param.Add("y=674")
		Page.Canvas.DrawText Request("BusinessName"), Param, Font

		' Draw an X mark in a business type box
		y = 649.8
		If Request("Type") = 0 Then x = 150.5
		If Request("Type") = 1 Then x = 229.6
		If Request("Type") = 2 Then x = 294.4
		If Request("Type") = 3 Then x = 352

		Page.Canvas.SetParams "color=black, linewidth=2"
		Page.Canvas.DrawLine x, y, x + 7, y - 7
		Page.Canvas.DrawLine x, y - 7, x + 7, y


		' Other
		If Request("Type") = 3 and Request("Other") <> "" Then
			Param.Add("x=397, y=653")
			Page.Canvas.DrawText Request("Other"), Param, Font
		End If

		' Exempt
		If Request("Exempt") = "on" Then
			x = 481
			Page.Canvas.DrawLine x, y, x + 7, y - 7
			Page.Canvas.DrawLine x, y - 7, x + 7, y
		End If

		' Address
		Param.Add("x=70, y=626")
		Page.Canvas.DrawText Request("Address"), Param, Font

		' City, State, Zip
		Param.Add("y=602")
		Page.Canvas.DrawText Request("City") & ", " & Request("State") & " " & Request("Zip"), Param, Font

		' SSN or EIN
		If Request("TIN") = 0 Then 
			y = 533
			TIN = Request("SSN")
		Else 
			y = 493
			TIN = Request("EIN")
		End If

		x = 433
		dX = 14.4 ' box size
		For i = 1 To len(TIN)
			If IsNumeric(Mid(TIN, i, 1)) Then
				Param("x") = x
				Param("y") = y
				Page.Canvas.DrawText Mid(TIN, i, 1), Param, Font
				x = x + dX
			End If
		Next

		' Date
		Param.Add("x=432, y=337")
		Page.Canvas.DrawText PDF.FormatDate(Now, "%b %d, %Y"), Param, Font

		' Signature - taken from a .gif file (image itself) and .bmp (mask)
		Set SignatureImg = Doc.OpenImage( Server.MapPath( "images/sig.jpg" ) )
		Set MaskImg = Doc.OpenImage( Server.MapPath( "images/sig.bmp" ) )
		MaskImg.IsMask = True
		SignatureImg.SetImageMask MaskImg ' For transparency purposes
		
		Page.Canvas.DrawImage SignatureImg, "x=164; y=280; scalex=.5, scaley=.5; angle=20"

		' We use Session ID for file names
		' false means "do not overwrite"
		' The method returns generated file name
		Path = Server.MapPath( "files") & "\" & Session.SessionID & ".pdf"
		FileName = Doc.Save( Path, false)

		Response.Write "<P><B>Success. Your PDF file <font color=gray>" & FileName & "</font> can be downloaded <A HREF=""files/" & FileName & """><B>here</B></A></B>."
		Set Page = Nothing
		Set Doc = Nothing
		Set Pdf = Nothing

	End If
%>
<P>
<B><A HREF="demo_fill.zip">Download source code (ASP and ASP.NET/C#) for this demo</A></B>

</FONT>
</TABLE>
</BODY>
</HTML>

